/*
 * Copyright 1995 Massachusetts Institute of Technology.  All Rights
 * Reserved.
 * 
 * You are hereby granted a worldwide, irrevocable, paid-up, right and
 * license to use, execute, display, modify, copy and distribute MIT's
 * Modifications, provided that (i) you abide by the terms and
 * conditions of your Transarc AFS License Agreement, and (ii) you do
 * not use the name of MIT in any advertising or publicity without the
 * prior written consent of MIT.  MIT disclaims all liability for your
 * use of MIT's Modifications.  MIT's Modifications are provided "AS
 * IS" WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
 * NOT LIMITED TO, ANY WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE OR NONINFRINGEMENT. 
 *
 * Parameter file for NetBSD on iAPX86 machines.
 *
 * Created by:  John Kohl <jtkohl@MIT.EDU>
 *
 * $Author: sommerfeld $
 * $Source: /afs/sipb.mit.edu/project/afs/repository/src/config/param.i386_nbsd1,v $
 */

#ifndef	_PARAM_I386_NBSD1_H_
#define	_PARAM_I386_NBSD1_H_

#include <afs/afs_sysnames.h>

#define AFS_VFSINCL_ENV    1
#define	AFS_NETBSD_ENV  1
#define AFS_386i_ENV	1	/* 386 Architecture--for lwp stuff */
#define AFS_UFSDIR_ENV  1
#define AFS_DIRENT
#define AFS_NEWCG_ENV
#define BSD43 1
#define ATHENA_ENV	1
#define AFS_ATHENA_ENV	1
#define	AFS_SYSCALL	210	/* first LKM syscall */

#define	AFS_NONFSTRANS	/* not with the BSD NFS server stuff! */
#define AFS_NORMTSYS	1

/* File system entry (used if mount.h doesn't define MOUNT_AFS */
#define AFS_MOUNT_AFS	9

/* Machine / Operating system information */
#define SYS_NAME	"i386_nbsd1"
#define SYS_NAME_ID	2000
#define AFSLITTLE_ENDIAN	1
#define NOASM
#define BITS32
#define BIG
#define BSDUNIX
#define LSBFIRST
#define USE_OLD_TTY
#define KTC_SYSCALL	AFS_SYSCALL

/* Extra kernel definitions (from kdefs file) */
#ifdef KERNEL
/* rt definitions here */
#define	AFS_SHORTGID	1		/* are group id's short? */
#define	afsio_iov	uio_iov
#define	afsio_iovcnt	uio_iovcnt
#define	afsio_offset	uio_offset
#define	afsio_seg	uio_segflg
#define	afsio_resid	uio_resid
#define	AFS_UIOSYS	UIO_SYSSPACE
#define	AFS_UIOUSER	UIO_USERSPACE
#define	AFS_CLBYTES	MB_CLBYTES
#define	AFS_MINCHANGE	2
#define	osi_GetTime(x)	microtime(x)
#define M_AFSFID	M_TEMP-1
#define M_AFSBUFHDR	M_TEMP-2
#define M_AFSBUFFER	M_TEMP-3
#define M_AFSGENERIC	M_TEMP-4

#if NetBSD < 199701
#define KMEMSTATS
#endif

#endif /* KERNEL */

#endif /* _PARAM_I386_NBSD1_H_ */
